SystemOrganization addCategory: #ConfigurationOfFuel!

Object subclass: #ConfigurationOfFuel
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFuel'!

!ConfigurationOfFuel class methodsFor: 'development support' stamp: 'MartinDias 2/19/2011 03:09'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfFuel class methodsFor: 'private' stamp: 'MartinDias 2/19/2011 03:09'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfFuel class methodsFor: 'private' stamp: 'MartinDias 2/19/2011 03:09'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfFuel class methodsFor: 'private' stamp: 'MartinDias 2/19/2011 03:09'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfFuel class methodsFor: 'metacello tool support' stamp: 'MartinDias 2/19/2011 03:09'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFuel class methodsFor: 'loading' stamp: 'MartinDias 2/19/2011 03:09'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFuel class methodsFor: 'loading' stamp: 'MartinDias 2/19/2011 03:09'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfFuel class methodsFor: 'loading' stamp: 'MartinDias 2/19/2011 03:09'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfFuel class methodsFor: 'hudson' stamp: 'MartinDias 8/10/2011 16:09'!
loadInHudson
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	(self project version: #bleedingEdge) load: #('CoreWithExtras' 'Tests' 'Benchmarks' 'FuelProgressUpdateBenchmarks' 'FuelLogo').
	(Smalltalk at: #FuelUtilities) cleanUpEverything. 
	(Smalltalk at: #FLLogoUtilities) installLogo.! !

!ConfigurationOfFuel class methodsFor: 'accessing' stamp: 'MartinDias 2/19/2011 03:09'!
project

	^self new project! !

!ConfigurationOfFuel class methodsFor: 'hudson' stamp: 'MarianoMartinezPeck 6/7/2011 09:22'!
testsCategoriesForHudson
	^ #('FuelContainer-Tests' 'FuelBenchmarks-Tests' 'FuelProgressUpdate-Tests' 'FuelTests-Collections' 'FuelTests' )! !

!ConfigurationOfFuel class methodsFor: 'development support' stamp: 'MartinDias 2/19/2011 03:09'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfFuel methodsFor: 'baselines' stamp: 'MartinDias 5/24/2011 15:26'!
baseline10: spec 
        <version: '1.0-baseline'>
        
        spec for: #pharo do: [
                spec blessing: #baseline.
                spec repository: 'http://www.squeaksource.com/Fuel'.    

                spec 
                        package: 'Fuel';
                        package: 'FuelBenchmarks' with: [ spec requires: 'Fuel' ];
                        package: 'FuelBenchmarksMC2' with: [ 
					spec 
						requires: 'FuelBenchmarks';
						requires: 'Monticello2' ];
                        package: 'FuelBenchmarksMagma' with: [ 
					spec
						requires: 'FuelBenchmarks';
						requires: 'Magma' ].

                spec
				project: 'Monticello2' with: [
				spec
					className: 'ConfigurationOfMonticello2';
					loads: #('DEFAULT');
					file: 'ConfigurationOfMonticello2';
					repository: 'http://source.wiresong.ca/mc/' ].
                spec
				project: 'Magma' with: [
				spec
					className: 'ConfigurationOfMagma';
					loads: #('default');
					file: 'ConfigurationOfMagma';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].

                spec
                        group: 'default' with: #('Fuel' 'Benchmarks' );
                        group: 'Core' with: #('Fuel');
                        group: 'Benchmarks' with: #('FuelBenchmarks');
				group: 'MC2Benchmarks' with: #('FuelBenchmarksMC2');
				group: 'MagmaBenchmarks' with: #('FuelBenchmarksMagma') ].! !

!ConfigurationOfFuel methodsFor: 'baselines' stamp: 'MartinDias 5/24/2011 15:26'!
baseline11: spec 
        <version: '1.1-baseline'>
        
        spec for: #pharo do: [
                spec blessing: #baseline.
                spec repository: 'http://www.squeaksource.com/Fuel'.    

                spec 
                        package: 'Fuel';
                        package: 'FuelBenchmarks' with: [ spec requires: 'Fuel' ];
                        package: 'FuelBenchmarksMC2' with: [ 
					spec 
						requires: 'FuelBenchmarks';
						requires: 'Monticello2' ];
                        package: 'FuelBenchmarksMagma' with: [ 
					spec
						requires: 'FuelBenchmarks';
						requires: 'Magma' ];
                        package: 'FuelProgressUpdate' with: [ spec requires: 'Fuel' ].


                spec
				project: 'Monticello2' with: [
				spec
					className: 'ConfigurationOfMonticello2';
					loads: #('DEFAULT');
					file: 'ConfigurationOfMonticello2';
					repository: 'http://source.wiresong.ca/mc/' ].
                spec
				project: 'Magma' with: [
				spec
					className: 'ConfigurationOfMagma';
					loads: #('default');
					file: 'ConfigurationOfMagma';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].

                spec
                        group: 'default' with: #('Fuel' 'Benchmarks' );
                        group: 'Core' with: #('Fuel');
                        group: 'CoreWithProgressBar' with: #('Fuel' 'FuelProgressUpdate');
                        group: 'Benchmarks' with: #('FuelBenchmarks');
				group: 'MC2Benchmarks' with: #('FuelBenchmarksMC2');
				group: 'MagmaBenchmarks' with: #('FuelBenchmarksMagma') ].! !

!ConfigurationOfFuel methodsFor: 'baselines' stamp: 'MartinDias 5/15/2011 19:00'!
baseline12: spec 
        <version: '1.2-baseline'>
        
        spec for: #pharo do: [
                spec blessing: #baseline.
                spec repository: 'http://www.squeaksource.com/Fuel'.    

                spec 
                        package: 'Fuel';
                        package: 'FuelBenchmarks' with: [ spec requires: 'Fuel' ];
                        package: 'FuelBenchmarksMC2' with: [ 
					spec 
						requires: 'FuelBenchmarks';
						requires: 'Monticello2' ];
                        package: 'FuelBenchmarksMagma' with: [ 
					spec
						requires: 'FuelBenchmarks';
						requires: 'Magma' ];
                        package: 'FuelProgressUpdate' with: [ spec requires: 'Fuel' ];
                        package: 'FuelContainer' with: [ spec requires: 'Fuel' ];
				package: 'FuelTests' with: [ spec requires: 'Fuel' ].


                spec
				project: 'Monticello2' with: [
				spec
					className: 'ConfigurationOfMonticello2';
					loads: #('DEFAULT');
					file: 'ConfigurationOfMonticello2';
					repository: 'http://source.wiresong.ca/mc/' ].
                spec
				project: 'Magma' with: [
				spec
					className: 'ConfigurationOfMagma';
					loads: #('default');
					file: 'ConfigurationOfMagma';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].

                spec
                        group: 'default' with: #('Fuel' 'Tests' 'Benchmarks' );
                        group: 'Core' with: #('Fuel');
                        group: 'CoreWithExtras' with: #('Fuel' 'FuelProgressUpdate' 'FuelContainer');
				group: 'Tests' with: #('FuelTests');
                        group: 'Benchmarks' with: #('FuelBenchmarks');
				group: 'MC2Benchmarks' with: #('FuelBenchmarksMC2');
				group: 'MagmaBenchmarks' with: #('FuelBenchmarksMagma') ].! !

!ConfigurationOfFuel methodsFor: 'baselines' stamp: 'MartinDias 8/10/2011 16:02'!
baseline15: spec 
        <version: '1.5-baseline'>
        
        spec for: #pharo do: [
                spec blessing: #baseline.
                spec repository: 'http://www.squeaksource.com/Fuel'.    

                spec 
                        package: 'Fuel';
				package: 'FuelTests' with: [ spec requires: 'Fuel' ];
                        package: 'FuelProgressUpdate' with: [ spec requires: 'Fuel' ];
                        package: 'FuelContainer' with: [ spec requires: 'Fuel' ];
                        package: 'FuelBenchmarks' with: [ spec requires: #('Fuel' 'FuelTests') ]; "TODO: remove dependency to FLPair"
                        package: 'FuelBenchmarksMagma' with: [ spec requires: #('FuelBenchmarks' 'MagmaBase') ];
                        package: 'FuelBenchmarksSIXX' with: [ spec requires: #('FuelBenchmarks' 'SIXX') ];
                        package: 'FuelBenchmarksStomp' with: [ spec requires: #('FuelBenchmarks' 'StOMP') ];
				package: 'FuelProgressUpdateBenchmarks' with: [ spec requires: #('FuelBenchmarks' 'FuelProgressUpdate') ];
                        package: 'FuelBenchmarksSRP' with: [ spec requires: #('FuelBenchmarks' 'SRP') ];
                        package: 'FuelBenchmarksEsAndEm' with: [ spec requires: #('FuelBenchmarks' 'EsAndEm') ];
                        package: 'FuelLogo'.


                spec
				project: 'MagmaBase' with: [
				spec
					className: 'ConfigurationOfMaBase';
					loads: #('default');
					file: 'ConfigurationOfMaBase';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].

                spec
				project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					loads: #('default');
					file: 'ConfigurationOfSIXX';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
				
		     spec
				project: 'StOMP' with: [
				spec
					className: 'ConfigurationOfStOMP';
					loads: #('default');
					file: 'ConfigurationOfStOMP';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].

			spec
				package: 'SRP' with: [ spec repository: 'http://www.squeaksource.com/SRP' ].

			spec
				package: 'EsAndEm' with: [ spec repository: 'http://source.wiresong.ca/mc' ].

			spec
				group: 'default' with: #('Core' 'Tests' 'Benchmarks');
				group: 'Core' with: #('Fuel');
				group: 'CoreWithExtras' with: #('Fuel' 'FuelProgressUpdate' 'FuelContainer');
				group: 'Tests' with: #('FuelTests');
				group: 'Benchmarks' with: #('FuelBenchmarks');
				group: 'BenchmarksSIXX' with: #('Benchmarks' 'FuelBenchmarksSIXX');
				group: 'BenchmarksAllBinarySerializers' with: #('Benchmarks' 'FuelProgressUpdateBenchmarks' 'FuelBenchmarksStomp' 'FuelBenchmarksMagma' 'FuelBenchmarksSRP' 'FuelBenchmarksEsAndEm') ].! !

!ConfigurationOfFuel methodsFor: 'accessing' stamp: 'MartinDias 2/19/2011 03:09'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfFuel methodsFor: 'symbolic versions' stamp: 'MartinDias 8/13/2011 22:35'!
stable: spec
	<symbolicVersion: #'stable'>
	spec for: #'pharo1.1.x' version: '1.4'. "Some tests fail in 1.5 and 1.6"
	spec for: #'pharo1.2.x' version: '1.6'.
	spec for: #'pharo1.3.x' version: '1.6'.
! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MartinDias 5/24/2011 15:26'!
version10: spec 
        <version: '1.0' imports: #('1.0-baseline') >
        
        spec for: #pharo do: [
                spec blessing: #release.
                spec 
                        package: 'Fuel' with: 'Fuel-MartinDias.84';
                        package: 'FuelBenchmarks' with: 'FuelBenchmarks-MartinDias.4';
				package: 'FuelBenchmarksMagma' with: 'FuelBenchmarksMagma-MartinDias.1';
				package: 'FuelBenchmarksMC2' with: 'FuelBenchmarksMC2-MartinDias.1' ].! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MartinDias 5/24/2011 15:26'!
version11: spec 
        <version: '1.1' imports: #('1.1-baseline') >
        
        spec for: #pharo do: [
                spec blessing: #release.
                spec 
                        package: 'Fuel' with: 'Fuel-MartinDias.84';
                        package: 'FuelBenchmarks' with: 'FuelBenchmarks-MartinDias.4';
				package: 'FuelProgressUpdate' with: 'FuelProgressUpdate-MartinDias.4';
				package: 'FuelBenchmarksMagma' with: 'FuelBenchmarksMagma-MartinDias.1';
				package: 'FuelBenchmarksMC2' with: 'FuelBenchmarksMC2-MartinDias.1' ].! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MartinDias 5/24/2011 15:25'!
version12: spec 
        <version: '1.2' imports: #('1.2-baseline') >
        
        spec for: #pharo do: [
                spec blessing: #release.
                spec 
                        package: 'Fuel' with: 'Fuel-MartinDias.193';
				package: 'FuelTests' with: 'FuelTests-MartinDias.2';
                        package: 'FuelBenchmarks' with: 'FuelBenchmarks-MarianoMartinezPeck.9';
				package: 'FuelProgressUpdate' with: 'FuelProgressUpdate-MartinDias.6';
				package: 'FuelContainer' with: 'FuelContainer-MartinDias.1';
				package: 'FuelBenchmarksMagma' with: 'FuelBenchmarksMagma-MartinDias.3';
				package: 'FuelBenchmarksMC2' with: 'FuelBenchmarksMC2-MartinDias.1' ].! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MarianoMartinezPeck 6/1/2011 14:04'!
version13: spec 
        <version: '1.3' imports: #('1.2-baseline') >
        
        spec for: #pharo do: [
                spec blessing: #release.
		    spec description: '
					- Class serialization without ClassBuilder.
					- MethodContext and BlockClosure serialization.
					- Some fixes on configuration itself
				'.
                spec 
                        package: 'Fuel' with: 'Fuel-MarianoMartinezPeck.225';
				package: 'FuelTests' with: 'FuelTests-MarianoMartinezPeck.21';
                        package: 'FuelBenchmarks' with: 'FuelBenchmarks-MarianoMartinezPeck.20';
				package: 'FuelProgressUpdate' with: 'FuelProgressUpdate-MartinDias.6';
				package: 'FuelContainer' with: 'FuelContainer-MartinDias.1';
				package: 'FuelBenchmarksMagma' with: 'FuelBenchmarksMagma-MartinDias.3';
				package: 'FuelBenchmarksMC2' with: 'FuelBenchmarksMC2-MartinDias.1' ].! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MarianoMartinezPeck 6/1/2011 14:03'!
version14: spec 
        <version: '1.4' imports: #('1.2-baseline') >
        
        spec for: #pharo do: [
                spec blessing: #release.
		    spec description: '
				- New support for serialization in memory
				- Name refactorings in some hierarchies and protocols.
				- Object cluster big refactoring
				- Hack that avoids several OrderedCollection>>makeRoomAtLast.
				- Other cleanups
			'.
                spec 
                        package: 'Fuel' with: 'Fuel-MartinDias.243';
				package: 'FuelTests' with: 'FuelTests-MarianoMartinezPeck.33';
                        package: 'FuelBenchmarks' with: 'FuelBenchmarks-MartinDias.26';
				package: 'FuelProgressUpdate' with: 'FuelProgressUpdate-MartinDias.8';
				package: 'FuelContainer' with: 'FuelContainer-MartinDias.1';
				package: 'FuelBenchmarksMagma' with: 'FuelBenchmarksMagma-MartinDias.3';
				package: 'FuelBenchmarksMC2' with: 'FuelBenchmarksMC2-MartinDias.1' ].! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MartinDias 8/13/2011 05:31'!
version15: spec 
	<version: '1.5' imports: #('1.5-baseline') >

	spec for: #pharo do: [
		spec blessing: #release.
		spec description: '
- Initialize instances after materialization implementing #fuelAfterMaterialization.
- Ignore transient instance variables overriding #fuelIgnoredInstanceVariableNames.
- Limit serialization progress bar to update at most once every 250 milliseconds.
- Traits are serialized and materialized as a regular objects (http://code.google.com/p/fuel/issues/detail?id=59).
- Removed mappers system cache (Eliot).
- Many new tests.
- Benchmarks: compare Fuel against StOMP, SRP, SIXX, Magma, EsAndEm and Fuel with progress bar.
- Benchmarks: new samples, scripts, and CSV exporter.	
- Benchmarks: measure serialization stream size.
- Removed some redundant #fuelAccept:.
- Several aesthetic changes in protocols, categories and comments.
- Now #materialize answers the materialized root.
- Removed special cluster for HashedCollection.Now #rehash is sended via #fuelAfterMaterialization.
- MethodContext serialization does not serialize temps (http://code.google.com/p/fuel/issues/detail?id=61).
- Classes and Traits now serialize its environment (testCreateWithSmalltalkGlobalsEnvironment).
- Fixed serialization of non-octet characters (testCharacter).
- Fixed a bug serializing the system dictionary. FLWellKnownObjectsCluster handles it. (testSmalltalkGlobals).
- Fixed a bug serializing class variables (testClassVariable).
- Fixed a bug when serializing a collection with size greater than 1^16 with repeated elements inside.
- Fixed testTwoCompiledMethodsReferencingSameClassVariable.
- Optimization: instanceIndexes are directly created with the exact size (Henrik).		
		'.
		spec 
			package: 'Fuel' with: 'Fuel-MartinDias.267';
			package: 'FuelTests' with: 'FuelTests-MarianoMartinezPeck.77';
			package: 'FuelBenchmarks' with: 'FuelBenchmarks-MartinDias.62';
			package: 'FuelProgressUpdate' with: 'FuelProgressUpdate-MartinDias.14';
			package: 'FuelContainer' with: 'FuelContainer-MartinDias.1';
			package: 'FuelBenchmarksMagma' with: 'FuelBenchmarksMagma-MarianoMartinezPeck.6';
			package: 'FuelBenchmarksSIXX' with: 'FuelBenchmarksSIXX-mariano.3';
			package: 'FuelBenchmarksStomp' with: 'FuelBenchmarksStomp-MarianoMartinezPeck.1';
			package: 'FuelProgressUpdateBenchmarks' with: 'FuelProgressUpdateBenchmarks-MarianoMartinezPeck.4';
			package: 'FuelBenchmarksEsAndEm' with: 'FuelBenchmarksEsAndEm-MarianoMartinezPeck.3';
			package: 'FuelLogo' with: 'FuelLogo-MartinDias.2';
			package: 'SRP' with: 'SRP-MartinDias.12';
			package: 'EsAndEm' with: 'EsAndEm-cwp.15'.
		spec
			project: 'MagmaBase' with: '1.0';
			project: 'SIXX' with: '0.3.6';
			project: 'StOMP' with: '1.8' ].! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MartinDias 8/15/2011 19:27'!
version16: spec 
	<version: '1.6' imports: #('1.5-baseline') >

	spec for: #pharo do: [
		spec blessing: #release.
		spec description: '
The changes included in this release are mostly a design clean up. They make code more understandable. They enable simpler extension. They are a necessary step forward to new functionalities that are coming. And happily they also improve serialization performance.

Details:
 - Removed explicit references to cluster classes scattered around the system. For example, in previous versions Float>>fuelCluster has an explicit reference to FLFloatCluster. This version replaces this by a double dispatch interaction.
 - Clusters: Better reification. Removed annoying IDs. Removed Singleton instance creation machanism, now mappers manage uniqueness in a better way. 
 - Mappers: They are greatly simplified. New mapping machanism inspired on Chain of Responsibility pattern. 
 - Analyzer: Part of its behavior and state has been moved to a new abstraction called *clusterization*.'.

		spec 
			package: 'Fuel' with: 'Fuel-MartinDias.322';
			package: 'FuelTests' with: 'FuelTests-MartinDias.82';
			package: 'FuelBenchmarks' with: 'FuelBenchmarks-MartinDias.68';
			package: 'FuelProgressUpdate' with: 'FuelProgressUpdate-MartinDias.15';
			package: 'FuelContainer' with: 'FuelContainer-MartinDias.1';
			package: 'FuelBenchmarksMagma' with: 'FuelBenchmarksMagma-MarianoMartinezPeck.6';
			package: 'FuelBenchmarksSIXX' with: 'FuelBenchmarksSIXX-mariano.3';
			package: 'FuelBenchmarksStomp' with: 'FuelBenchmarksStomp-MarianoMartinezPeck.1';
			package: 'FuelProgressUpdateBenchmarks' with: 'FuelProgressUpdateBenchmarks-MarianoMartinezPeck.4';
			package: 'FuelBenchmarksEsAndEm' with: 'FuelBenchmarksEsAndEm-MarianoMartinezPeck.3';
			package: 'FuelLogo' with: 'FuelLogo-MartinDias.2';
			package: 'SRP' with: 'SRP-MartinDias.12';
			package: 'EsAndEm' with: 'EsAndEm-cwp.15'.
		spec
			project: 'MagmaBase' with: '1.0';
			project: 'SIXX' with: '0.3.6';
			project: 'StOMP' with: '1.8' ].! !

!ConfigurationOfFuel methodsFor: 'versions' stamp: 'MartinDias 8/13/2011 05:26'!
version17: spec 
	<version: '1.7' imports: #('1.5-baseline') >

	spec for: #pharo do: [
		spec blessing: #development.
		].! !
